#ifndef BALL_H
#define BALL_H

#include "wall.h"
#include "roots.h"
#include <math.h>

class Ball {
public:
	Ball();
	void move(double t);
	double getCollideTime(const Wall &w, int ID) const;
	double getCollideTime(const Ball &w, int ID) const;
	void collide(const Wall &w, int ID);
	void collide(Ball &b, int ID);
	bool overlap(const Ball &b) const;
	bool overlap(const Wall &b) const;

	double getX() const;
	double getY() const;
	double getRadius() const;
	double getKinEnergy() const;
	double getPotEnergy() const;
	double getXVel() const;
	double getYVel() const;
	double getXAccel() const;
	double getYAccel() const;
	unsigned int getColor() const;
	void setRadius(double r);
	void setPos(double x, double y);
	void setSpeed(double x, double y);
	void setAccel(double x, double y);
	void setMass(double m);
	void setColor(unsigned int c);
	void setColor(int r, int g, int b);
private:
	int colID;
	unsigned int color;
	double radius;
	double mass;
	// the position of the ball
	double cx, cy;
	// the speed of the ball
	double vx, vy;
	// the acceleration of the ball
	double ax, ay;

	double OneDCollideTime(double d, double v, double a) const;
	double getOneDWallDistance(double wpos, double c) const;
};

#endif
