#ifndef BENGBOX_H
#define BENGBOX_H

#include "ball.h"

class BengBox {
public:
	BengBox(int number, double w, double h);
	~BengBox();
	void step(double timestep); //seconds
	void removeOverlap();

	const Ball *getBall(int i) const;
	Ball *getBall(int i);
	unsigned int numBalls() const;
private:
	/* list of seconds since begin current timestep that an event will occur. A negative time means the event will not occur. */
	double *eventtime;
	/* total amount of possible events. Each ball can bump into a wall. Every pair of balls can collide. This means there is a total of 4*n+n*(n-1)/2 events possible. */
	int events;
	bool *update;
	// all balls in the box
	Ball *ball;
	// the number of balls
	int balls;
	// all walls in the box
	Wall *wall;
	// the number of walls
	int walls;

	void seteventtimes();
	void move(double t);
	// apply event
	void doevent(const double t);
	// apply collision between wall and ball
	void collide(int, Wall);
	// apply collision between ball and ball
	void collide(int, int);
};

#endif
