#ifndef BENGCANVAS
#define BENGCANVAS

#include <qcanvas.h>
#include <vector>
using std::vector;

class Ball;
class BengBox;

class BengBall : public QCanvasEllipse {
public:
	BengBall(double r, QCanvas *c, Ball *b);
	Ball *b;
	void move();
	void setRadius(double);
};

class BengCanvas : public QCanvas {
public:
	BengCanvas();
	~BengCanvas();
	void setUpdatePeriod(int);
	void setPolydispersity(double p);
	double getPolydispersity() const;
	void setRadius(double r);
	double getRadius() const;
	void setNumBalls(uint n);
	uint getNumBalls() const;
	void setQueens(uint i);
	uint getQueens() const;
	void resize(int, int);
protected:
	void update();
private:
	bool ready;
	bool swarm;
	unsigned int n;
	unsigned int updatePeriod;
	unsigned int queens;
	double radius;
	double polydisp;
	double energy;
	double acceleration;
	double pi;
	vector<BengBall *> balls;
	BengBox *box;
	
	void reset();
	void placeBalls();
	void checkEnergy();
	void swarmBalls();
};

#endif
