#ifndef BENGSAVER_H
#define BENGSAVER_H

#include <config.h>
#include <kscreensaver.h>

class Timer;
class QCanvas;
class QCanvasView;
class SwarmBox;
#ifdef HAVE_GL
class GLBox;
#endif

class BengSaver : public KScreenSaver {
	Q_OBJECT
public:
	BengSaver(WId drawable);
	virtual ~BengSaver();
	void setPolydispersity(double p);
	void setRadius(double r);
	void setNumBalls(uint n);
	void setQueens(uint i);
	void setBackColor(const QColor &);
	void setBigColor(const QColor &);
	void setSmallColor(const QColor &);
	void setQueenColor(const QColor &);
public slots:
	void set3D(bool);
	void update();
private:
	bool ready;
	bool threeD;
	int numberOfBalls;
	int numberOfQueens;
	double polydispersity;
	double radius;
	SwarmBox *sb;
	QColor backcolor, bigcolor, smallcolor, queencolor;
	QCanvasView *qcv;
	QCanvas *qc;
	QTimer *timer;
	void readSettings();
	void updateCanvas();
#ifdef HAVE_GL
	GLBox *gl;
	void updateOpenGL();
#endif
};

#endif
