#ifndef BENGSETUP_H
#define BENGSETUP_H

#include <qdialog.h>

class BengSaver;
class QSlider;
class QLabel;

class BengSetup : public QDialog {
	Q_OBJECT
public:
	BengSetup(QWidget *parent=0, const char *name=0, WFlags f=0);
protected:
	void readSettings();
private slots:
	void okPressed();
	void polydispChanged(int p);
	void radiusChanged(int r);
	void numBallsChanged(int b);
	void numQueensChanged(int q);
	void backColorChanged(const QColor &);
	void bigColorChanged(const QColor &);
	void smallColorChanged(const QColor &);
	void queenColorChanged(const QColor &);
	void about() const;
	void switch3D(int);
private:
	QColor backcolor, bigcolor, smallcolor, queencolor;
	QLabel *ballLabel, *queenLabel;
	QWidget *preview;
	QSlider *queens;
	BengSaver *saver;

	bool threeD;
	uint numberOfBalls;
	uint numberOfQueens;
	double polydispersity;
	double radius;
};

#endif
