#include <config.h>
#ifdef HAVE_GL
#ifndef GLBOX_H
#define GLBOX_H

#include <qgl.h>
#include <vector>
using namespace std;

struct ThreeDBall {
	GLfloat radius;
	GLfloat x;
	GLfloat y;
	QColor c;
};

class GLBox : public QGLWidget {
public:
	GLBox( QWidget* parent, const char* name="" );
	~GLBox();
	void setBackgroundColor ( const QColor & c );
	void setNumBalls(uint n);
	uint getNumBalls() const;
	void setBallCoord(uint n, double, double);
	void setBallRadius(uint n, double);
	void setBallColor(uint n, QColor c);
protected:
	void initializeGL();
	void paintGL();
	void resizeGL( int w, int h );
private:
	GLUquadricObj* gobj;
	GLfloat depth, zpos;
	QColor backcolor;
	vector<ThreeDBall> balls;
};

#endif // GLBOX_H
#endif // HAVE_GL
