#ifndef SWARMBOX
#define SWARMBOX

#include <vector>
using std::vector;

class Ball;
class BengBox;

class SwarmBox {
public:
	SwarmBox();
	~SwarmBox();
	void setUpdatePeriod(int);
	void setPolydispersity(double p);
	double getPolydispersity() const;
	void setRadius(double r);
	double getRadius() const;
	void setNumBalls(uint n);
	uint getNumBalls() const;
	void setQueens(uint i);
	uint getQueens() const;
	int getUpdatePeriod() const;
	Ball *getBall(uint i) const;
	void resize(int, int);
	void update();
	void setBigColor(unsigned int c);
	void setSmallColor(unsigned int c);
	void setQueenColor(unsigned int c);
	int width() const;
	int height() const;
private:
	bool ready;
	bool swarm;
	unsigned int n;
	unsigned int w, h;
	unsigned int updatePeriod;
	unsigned int queens;
	unsigned int bigcolor, smallcolor, queencolor;
	double radius;
	double polydisp;
	double energy;
	double acceleration;
	double pi;
	BengBox *box;
	
	void reset();
	void placeBalls();
	void checkEnergy();
	void swarmBalls();
	void updateColors();
	void setColor(double f, Ball *b) const;
};

#endif
